// RPClient.h : RPCLIENT AvP[ṼC wb_[ t@CłB
//

#if !defined(AFX_RPCLIENT_H__8EA966B3_CF03_42F0_8238_3FB90AEFDED5__INCLUDED_)
#define AFX_RPCLIENT_H__8EA966B3_CF03_42F0_8238_3FB90AEFDED5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// C V{
#include "Client.h"
#include "RPDialog.h"
/////////////////////////////////////////////////////////////////////////////
#define	RTIMEOUT	3000
#define	WTIMEOUT	3000
#define	STIMEOUT	3000
#define	WTIMERINTERVAL 3000

enum {
	MMR_DEFCOMMAND,
	MMR_VFO,
};
#define	mmrpstatusRX		0x0001
#define	mmrpstatusTXBUSY	0x0002
#define	mmrpstatusFREQ		0x0004
#define	mmrpstatusDEFCMD	0x0008
/////////////////////////////////////////////////////////////////////////////
// CRPClientApp
class CRPClientApp : public CWinApp
{
private:
	int			m_TcpRetryTime;
	CString		m_ServerName;
	int			m_PortTCP;
	CTcpFifo	m_TcpFifo;

	HWND		m_hWnd;
	UINT		m_uMsg;

	int			m_Busy;
	int			m_ptt;
	CFifo		m_RxD;
	DWORD		m_Freq;
    LONG		m_DefCmd;

private:
	CRPDialog	*m_pDialog;
	CClient		*m_pSocket;
	COLORREF	m_clBack;

private:
	void SetEXT(LPSTR s, LPCSTR pKey);
	BOOL CreateSocket(LPCSTR pName, UINT port);
	void DeleteSocket(void);
	BOOL IsConnected(void){return m_pSocket != NULL;}
	BOOL SendBuf(LPVOID p, int n);
	BOOL SendServer(TCPD *tp);
	BOOL SendServer(int cmd, LPVOID p, UINT len);

public:
	void OnTimer(void);
	void ReqConnect(void);
	void ReqDisconnect(void);
	void DispStatus(void);
	void OnReceive(int nErrorCode);
	inline COLORREF GetBackColor(void){return m_clBack;};

	inline CWnd *GetDialogWindow(void){return m_pDialog;}
	LRESULT OnSocketEvent(WPARAM wParam, LPARAM lParam);

public:
	void mmSetHandle(HWND hWnd, UINT uMsg);
	DWORD mmGetStatus(void);
	void mmSetPTT(LONG tx);
	void mmPutChar(BYTE c);
	BYTE mmGetChar(void);
	void mmPolling(void);
	LONG mmGetFreq(void);
	LONG mmGetDefCommand(void);

public:
	CRPClientApp();

// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CRPClientApp)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CRPClientApp)
		//  -  ClassWizard ͂̈ʒuɃo֐ǉ܂͍폜܂B
		//         ̈ʒuɐR[hҏWȂłB
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

inline CRPClientApp *GetApp(void){ return (CRPClientApp *)AfxGetApp();};
inline COLORREF GetBackColor(void){ return ((CRPClientApp *)AfxGetApp())->GetBackColor();};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_RPCLIENT_H__8EA966B3_CF03_42F0_8238_3FB90AEFDED5__INCLUDED_)
