#if !defined(AFX_WLDIALOG_H__2022735E_4A39_42D8_9C18_91D1ABF382FF__INCLUDED_)
#define AFX_WLDIALOG_H__2022735E_4A39_42D8_9C18_91D1ABF382FF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// WLDialog.h : wb_[ t@C
//
#include "ColorStatic.h"

class CRPClientApp;
/////////////////////////////////////////////////////////////////////////////
// CRPDialog _CAO

class CRPDialog : public CDialog
{
private:
	BOOL			m_Japanese;
	CRPClientApp	*m_pApp;
	UINT			m_nTimerID;
	CColorStatic	m_Status;
	CFont			*m_pFont;

public:
	void WindowControl(LPRECT pRect, int cmd);
	void UpdateButton(BOOL enabled);
	void GetServerName(CString &name);
	void UpdateStatus(LPCSTR pStatus, COLORREF col);

	BOOL IsAutoConnect(void);
// RXgNV
public:
	CRPDialog(CWnd* pParent = NULL, CRPClientApp *pApp = NULL);   // W̃RXgN^

// _CAO f[^
	//{{AFX_DATA(CRPDialog)
	enum { IDD = IDD_DIALOG };
	CButton	m_BConnect;
	BOOL	m_AutoConnect;
	CString	m_ServerName;
	//}}AFX_DATA


// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CRPDialog)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CRPDialog)
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnBconnect();
	afx_msg void OnAconnect();
	virtual BOOL OnInitDialog();
	afx_msg void OnMinimize();
	afx_msg void OnChangeEditserver();
	//}}AFX_MSG
	afx_msg LRESULT OnSocketEvent(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_WLDIALOG_H__2022735E_4A39_42D8_9C18_91D1ABF382FF__INCLUDED_)
