// RPServer.cpp : AvP[VpNX̒`s܂B
//

#include "stdafx.h"
#include "RPServer.h"
#include "RPServerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CExistApp
CExistApp::CExistApp()
{
	m_hComFile = NULL;
}
//---------------------------------------------------------------------------
CExistApp::~CExistApp()
{
	if( m_hComFile ){
		CloseHandle(m_hComFile);
		m_hComFile = NULL;
	}
}
//---------------------------------------------------------------------------
BOOL CExistApp::IsExist(LPCSTR pKey)
{
	m_hComFile = ::OpenFileMapping(FILE_MAP_ALL_ACCESS, FALSE, pKey);
	if( m_hComFile != NULL ){
		HWND *phWnd = (HWND *)::MapViewOfFile(m_hComFile, FILE_MAP_ALL_ACCESS, 0, 0, 0);
		if( phWnd ){
			HWND hWnd = *phWnd;
			::UnmapViewOfFile(phWnd);
			if( IsWindow(hWnd) ){
				::ShowWindow(hWnd, SW_SHOW);
				::SetForegroundWindow(hWnd);
			}
		}
		return TRUE;
	}
	m_hComFile = (HANDLE)::CreateFileMapping(HANDLE(0xffffffff), NULL, PAGE_READWRITE, 0, sizeof(HWND), pKey);
	if( m_hComFile ){
		HWND *phWnd = (HWND *)::MapViewOfFile(m_hComFile, FILE_MAP_WRITE, 0, 0, 0);
		*phWnd = NULL;
		::UnmapViewOfFile(phWnd);
	}
	return FALSE;
}
//---------------------------------------------------------------------------
void CExistApp::RegisterWindow(HWND hWnd)
{
	if( m_hComFile ){
		HWND *phWnd = (HWND *)::MapViewOfFile(m_hComFile, FILE_MAP_WRITE, 0, 0, 0);
		if( phWnd ){
			*phWnd = hWnd;
			::UnmapViewOfFile(phWnd);
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
// CRPServerApp

BEGIN_MESSAGE_MAP(CRPServerApp, CWinApp)
	//{{AFX_MSG_MAP(CRPServerApp)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
		//        ̈ʒuɐR[hҏWȂłB
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRPServerApp NX̍\z

CRPServerApp::CRPServerApp()
{
	m_clBack = RGB(192,192,192);
}

/////////////////////////////////////////////////////////////////////////////
// B CRPServerApp IuWFNg

CRPServerApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CRPServerApp NX̏

BOOL CRPServerApp::InitInstance()
{
#ifndef _DEBUG
	if( m_ExistApp.IsExist("RPServer") ) return FALSE;
#endif

	if(!AfxSocketInit()){
		AfxMessageBox(IDP_SOCKETS_INIT_FAILED);
		return FALSE;
	}
	m_clBack = GetSysColor(COLOR_BTNFACE);
	SetDialogBkColor(m_clBack);

	char IniName[MAX_PATH];
	::GetModuleFileName(m_hInstance, IniName, sizeof(IniName));
	SetEXT(IniName, "ini");
	if( m_pszProfileName ) free(LPVOID(m_pszProfileName));
	m_pszProfileName = _tcsdup(IniName);

	CRPServerDlg dlg;
	m_pMainWnd = &dlg;
	int nResponse = dlg.DoModal();
	return FALSE;
}

//---------------------------------------------------------------------------
void CRPServerApp::SetEXT(LPSTR s, LPCSTR pKey)
{
	int len = strlen(s);
	if( !len ) return;
	LPSTR t = s + len - 1;
	for( ; t > s; t-- ){
		if( *t == '.' ){
			t++;
			strcpy(t, pKey);
			return;
		}
	}
	t = s + len - 1;
	*t++ = '.';
	strcpy(t, pKey);
}
