#if !defined(AFX_CSOCKET_H__CBD2F8CF_7475_4B87_B7DD_957963631EB9__INCLUDED_)
#define AFX_CSOCKET_H__CBD2F8CF_7475_4B87_B7DD_957963631EB9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CSocket.h : wb_[ t@C
//
#define	WM_SOCKETEVENT	WM_USER+402
enum {
	MMSO_STATUS,
	MMSO_CLOSE,
	MMSO_CONNECT,
	MMSO_MONICLOSE,
};
/////////////////////////////////////////////////////////////////////////////
// CTcpFifo class
//---------------------------------------------------------------------------
#define TCPFIFOMAX  128
#pragma pack(push, 1)
typedef struct {        // {ʐM\
	BYTE    ID;
	BYTE    Type;
	BYTE    len;
	BYTE    Data[8];
}TCPD;
#pragma pack(pop)
enum {
	cmdPutChar,
	cmdPTT,
	cmdPolling,
};
enum {
	retInit,
	retBusy,
	retChar,
	retFreq,
};
void __fastcall MakeTCPD(TCPD *tp, int Type, void *bp, int n);
///---------------------------------------------------------
///  oCiehen
class CTcpFifo
{
private:
	TCPD    Slot[TCPFIFOMAX];
	TCPD    *tp;
	BYTE    *wp;
	int     WL;
	int     RL;
	int     Len;
	int     Mode;
	int     Line;
	int		Err;
public:
	CTcpFifo(void);
	~CTcpFifo(void);
	inline int __fastcall GetErr(void){return Err;};
	void __fastcall Reset(void);
	void __fastcall WriteByte(BYTE c);
	void __fastcall WriteString(LPCSTR sp);
	void __fastcall Write(const BYTE *sp, int n);
	inline int __fastcall GetLine(void){return Line;};
	TCPD* __fastcall GetData();
};


class CRPServerDlg;

/////////////////////////////////////////////////////////////////////////////
// CCSocket R}h ^[Qbg

class CCSocket : public CSocket
{
	DECLARE_DYNAMIC(CCSocket);

private:
	CRPServerDlg	*m_pDlg;
	BOOL			m_EnabledEvent;
public:
	inline void EnableEvent(BOOL enabled){m_EnabledEvent = enabled;};
// Agr[g
public:

// Iy[V
public:
	CCSocket(CRPServerDlg *pDlg);
	virtual ~CCSocket();

// I[o[Ch
public:
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CCSocket)
	public:
	virtual void OnReceive(int nErrorCode);
	virtual void OnClose(int nErrorCode);
	//}}AFX_VIRTUAL

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CCSocket)
		//  - ClassWizard ͂̈ʒuɃo֐ǉ܂͍폜܂B
	//}}AFX_MSG

// Cve[V
protected:
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_CSOCKET_H__CBD2F8CF_7475_4B87_B7DD_957963631EB9__INCLUDED_)
